import { ElementRef, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/common';
import { Search, SearchValueAccessor } from '../search';
import { SelectOption } from './select-option.component';
import { DropdownMenu } from '../dropdown';
export declare class Select extends Search implements OnInit {
    private el;
    protected _menu: DropdownMenu;
    searchClasses: boolean;
    isSearchable: boolean;
    allowMultiple: boolean;
    searchDelay: number;
    protected _loading: boolean;
    placeholder: string;
    selectedOptionHTML: string;
    selectedOptions: any;
    selectedOptionsHTML: Array<string>;
    maxSelected: number;
    private maxSelectedReached;
    renderedOptions: Array<SelectOption>;
    isOpen: boolean;
    protected results: Array<any>;
    constructor(el: ElementRef);
    ngOnInit(): void;
    selectOption(selectOption: SelectOption): void;
    deselectOption(option: any): void;
    private selectedOptionClick(event);
    private focusSearch();
    private focusFirstItem();
    writeValue(value: any): void;
    click(event: MouseEvent): boolean;
    searchKeyDown(event: KeyboardEvent): void;
}
export declare class SelectValueAccessor extends SearchValueAccessor implements ControlValueAccessor {
    constructor(host: Select);
}
